/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1995 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, modify, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	ccx.c (Character Code Translator)
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	951111	created
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>

FILE *fopenArg(ai,ac,av,mode)
	char *av[],*mode;
{	FILE *fp;
	char *file;

	if( ac <= ai ){
		fprintf(stderr,"file not specified.\n");
		exit(1);
	}

	file = av[ai];
	if( file == 0 )
		exit(1);

	fp = fopen(file,mode);
	if( fp == NULL ){
		fprintf(stderr,"cannot fopen(%s,%s)\n",file,mode);
		exit(1);
	}
	return fp;
}

main(ac,av)
	char *av[];
{	int ai,cc;
	char *arg,*lang;
	FILE *fp;

	lang = "CN2JP";
	for( ai = 1; ai < ac; ai++ ){
		arg = av[ai];
		if( strcmp(arg,"-l") == 0 ){
			ai++;
			fp = fopenArg(ai,ac,av,"r");
			cc = CCX_getTable(lang,fp);
			fclose(fp);
			fprintf(stderr,"CCX table %s loaded (%d bytes)\n",
				lang,cc);
			continue;
		}
		if( strcmp(arg,"-d") == 0 ){
			ai++;
			fp = fopenArg(ai,ac,av,"w");
			cc = CCX_putTable(lang,fp);
			fclose(fp);
			fprintf(stderr,"CCX table %s dumped (%d bytes)\n",
				lang,cc);
			continue;
		}
		if( strcmp(arg,"-") == 0 )
			fp = stdin;
		else{
			fp = fopen(arg,"r");
			if( fp == NULL ){
				fprintf(stderr,"cannot open %s\n",arg);
				exit(1);
			}
		}
		any_to_jis_file(fp,stdout,"?");
	}
	exit(0);
}
TO_JIS(any,jis,ctype)
	char *any,*jis,*ctype;
{
	strcpy(jis,any);
}

