/* $Id: jis2ejis.c1.2 1992/07/31 03:31:40 ygz Exp $ */

#ifndef lint
static char *rcs_id="$Id: hz2gb.c,v 1.2 1992/07/31 03:31:40 ygz Exp $";
#endif /* lint */

#include <stdio.h>

#define	hzb(c)	((((c) & 0x7f) >= 0x21) && (((c) & 0x7f) <= 0x7e))
#define ejis(c) ( ((c) >= 0xa1 ) && ((c) <= 0xfe) )

int debug = -1;
static unsigned char	buffer[2048];
int	upzj=1;

#define S_ASC	0
#define MAX_PY_TBL     2066
char*   big_to_ejis();
typedef unsigned char mnemonic[10];
extern  mnemonic *py_tbl,*py_tbl3;
extern  unsigned char *BtoEJ;
 

struct code_table {
        char    tbl_name[20];
        int     row;
        int     char_per_row;
        char    *tbl;
        int     loaded;
        int     length3_tbl_size;
        int     *length3_tbl;
}  table;




/*
	Big to EUC-Jis
*/
char *
BIG5_TO_EUCJP(istr,ostr)
char	*istr, *ostr;
{
	char 	buf[2048],c1,c2,e1,e2;
	unsigned	i,hi,lo,o_len,seq_b5,jis,big,index_py,a,b,ilen;	

	ilen = strlen(istr);
	o_len=0;

	for(i=0; i<ilen; i++) {
		c1=istr[i];
		if((c1&0x80)==0) 
			ostr[o_len++]=c1;
		else {
			c2=istr[++i];
			hi=c1&0xff; lo=c2&0xff;
			big=lo+(hi<<8);
			a=(hi-0xa1)*157;
			b=(lo<0x7f) ? (lo-0x40+1) : (lo-0xa1+63+1);
                	seq_b5=a+b;
			e1=BtoEJ[(seq_b5-1)*2];
			e2=BtoEJ[(seq_b5-1)*2+1];
if(debug>0)
        printf("\n(big=%x,seq=%d) (a=%d,b=%d) (e1=%x,e2=%x)",big,seq_b5,a,b,e1&0xff,e2&0xff);
			if((e1&0x80)||(hi<0xa4)) {
				jis=e2&0xff + ((e1&0xff)<<8);
if(debug>0) {
	if((big==0xb6c0)||(big==0xb7b3))
                printf("\n(big=%x,seq=%d) (jis=%x)",big,seq_b5,jis);
}
				ostr[o_len++]=e1;
				ostr[o_len++]=e2;
			} else {
                                index_py= (e1-0x21) * 94 + (e2-0x21);
				if((index_py<MAX_PY_TBL)&&(index_py>=0)) {
                                        if(upzj==1) {
                                        ostr[o_len++]=py_tbl3[index_py][0];
                                        ostr[o_len++]=py_tbl3[index_py][1];
                                        } else {
                                        ostr[o_len++]='[';
                                        strcpy(&ostr[o_len],py_tbl[index_py]);
                                        o_len += strlen(py_tbl[index_py]);
                                        ostr[o_len++]=']';
                                        }
				} else {
if(debug>0) 
	printf("\n(big=%x,seq=%d) (e1=%x,e2=%x)", big,seq_b5,e1,e2);
				}
			}
		}
	}

if(debug>-1)
	if(o_len>2000) printf("\nWarning: o_len=%d",o_len);

	ostr[o_len++]=0;
	return ostr;
}


char *
BIG5_TO_JIS(istr,ostr)
char	*istr, *ostr;
{
	char	*euc;


	BIG5_TO_EUCJP(istr,ostr);

	euc = (char *)malloc(strlen(ostr)+1024);

	TO_JIS(ostr,euc,"");

	strcpy(ostr,euc);

	free(euc);

	return ostr;
}


/*
	EUC-Jis to Big
*/
char *
EUCJP_TO_BIG5(istr,ilen,olen)
char    *istr;
int     ilen,*olen;
{
        static unsigned char    ostr[1024],buf[256],c1,c2,e1,e2;
        unsigned        i,hi,lo,o_len;
        int     seq;


        /* do translation */
        o_len=0;
        for(i=0; i<ilen; i++) {
                c1=istr[i];
                if((c1&0x80)==0)
                        /* copy chars below 0x80 */
                        ostr[o_len++]=c1;
                else {
                        /* translate ejis */
                        c2=istr[++i];

                        seq = seq_ejis(c1, c2);

                        if (seq > 0)
                                jis_seq2big(seq, buf);

                        strcpy(&ostr[o_len],buf);
                        o_len += strlen(buf);

if(debug> 1)
        printf("\n(ejis=%x%x,seq=%d) (%s)", c1, c2, seq, buf);

                }
        }

        ostr[o_len++]=0;
        *olen = o_len;

        return (char *) ostr;
}


/*
	GB to EUC-Jis
*/
#define UNDEFCHAR 0x2020
static int JIS=2;
static int UZPJ=1;

char *
GB_TO_EUCJP(istr,ostr)
char	*istr, *ostr;
{
	unsigned char 	buf[2048],c1,c2,e1,e2;
	unsigned int	i,h,l,o_len,seq_b5,jis,big,index_py,a,b,ilen,new;	
	extern unsigned short *GB2312JX0208[],*GB2312JX0212[],*GB2312UZPJ[];



	ilen = strlen(istr);
	o_len=0;

	for(i=0; i<ilen; i++) {
		c1=istr[i];
		if((c1&0x80)==0) 
			ostr[o_len++]=c1;
		else {
			c2=istr[++i];

			h = c1 - 161;
			l = c2 - 161;

		      	if(JIS==0&&GB2312JX0212[h][l]>0)
       			  new=GB2312JX0212[h][l];
			else if(UZPJ>0&&GB2312UZPJ[h][l]>0)
			  new=GB2312UZPJ[h][l];
			else if(GB2312JX0208[h][l]>0)
			  new=GB2312JX0208[h][l];
			else
			  new=UNDEFCHAR;

			e2=new&255;
			e1=new>>8;

			ostr[o_len++]=e1;
			ostr[o_len++]=e2;
if(debug>0)
	printf("\n(gb=%x%x) -> (e1=%x,e2=%x)", c1, c2, e1, e2);

		}


	}

if(debug>-1)
	if(o_len>2000) printf("\nWarning: o_len=%d",o_len);

	ostr[o_len++]=0;
	return ostr;

}

char *
GB_TO_JIS(istr,ostr)
char	*istr, *ostr;
{
	char	*euc;


	GB_TO_EUCJP(istr,ostr);

	euc = (char *)malloc(strlen(ostr)+1024);

	TO_JIS(ostr,euc,"");

	strcpy(ostr,euc);

	free(euc);

	return ostr;
}



char *
HZ_TO_EUCJP(istr,ostr)
char	*istr, *ostr;
{
	char	*euc;


	hz2gb(istr,ostr);

	euc = (char *)malloc(strlen(ostr)+1024);

	GB_TO_EUCJP(ostr,euc,"");

	strcpy(ostr,euc);

	free(euc);

}


char *
HZ_TO_JIS(istr,ostr)
char	*istr, *ostr;
{
	char	*euc;


	hz2gb(istr,ostr);

	euc = (char *)malloc(strlen(ostr)+1024);

	GB_TO_JIS(ostr,euc,"");

	strcpy(ostr,euc);

	free(euc);

}


/*
        find the sequence number of the ejis code (c1,c2)
*/
int
seq_ejis(c1,c2)
unsigned char   c1,c2;
{
        unsigned int    hi,lo,a,b,result;


        result = -1;
        if((c1>=0xa1) && (c1<=0xfe) && (c2>=0xa1) && (c2<=0xfe)) {
                hi = c1 & 0xff;  lo = c2 & 0xff;
                a=(hi-0xa1)*94;
                b=lo-0xa1;

                result = a + b + 1;
        } else {
                result = 9;  /* question mark */
        }

        return result;
}

/*
        ejis2jis.t related functions
                jis_seq2big()
                ejis2big_init()
*/
jis_seq2big(seq, buf)
int     seq;
unsigned char   *buf;
{
        int     index,offset;
        char    *str3;

        buf[0] = 0;
        if((table.loaded) && (seq <= table.row * table.char_per_row)) {
                buf[0]=table.tbl[(seq-1)*2];
                buf[1]=table.tbl[(seq-1)*2+1];
                buf[2]=0;

if(debug> 1)
        printf("\n(buf=%x%x,seq=%d) (%s)", buf[0], buf[1], seq, buf);

                if((buf[0]>=0x80) && (buf[0]<=0x9f)) {
                        index=(buf[0]-0x80)*256 + buf[1];
                        if(index < table.length3_tbl_size) {
                                offset = table.length3_tbl[index];
                                str3 = (char *) table.length3_tbl;
                                str3 += offset;
                                strcpy(buf,str3);

                        }
                        else {
                                fprintf(stderr,"\njis_seq2big: (Warning) Unknown length3_tbl_i ndex=%d", index);
                                buf[0] = 0xa1;
                                buf[1] = 0x49;
                        }
                }
                else {
                        buf[2]=0;
                }
        }

        return 0;
}



char *toejis (s,plen,inst)
     char *s;
     int *plen;
     int inst;
{
  int i,j,in_jis,buf;

	in_jis=0; buf=0;
	for (i = 0; i < *plen; i++) {
		if(((i<*plen-4)&&(s[i]=='^')&&(s[i+1]=='[')
			&&(s[i+2]=='$')&&(s[i+3]=='@'))
		|| ((i<*plen-4)&&(s[i]=='^')&&(s[i+1]=='[')
			&&(s[i+2]=='$')&&(s[i+3]=='B'))) {
/*
			strncpy(&buffer[buf],&s[i],4);
			buf += 4;
*/
			i += 3;
			in_jis=1;
if(debug>1)
	buffer[buf++]='<'; 
		} else if(((i<*plen-4)&&(s[i]=='^')&&(s[i+1]=='[')
			&&(s[i+2]=='(')&&(s[i+3]=='J'))
		|| ((i<*plen-4)&&(s[i]=='^')&&(s[i+1]=='[')
			&&(s[i+2]=='(')&&(s[i+3]=='B'))) {
/*
			strncpy(&buffer[buf],&s[i],4);
			buf += 4;
*/
			i += 3;
			in_jis=0;
if(debug>1)
	buffer[buf++]='>'; 
		}
		else if(in_jis) buffer[buf++]=s[i]|0x80;
		else buffer[buf++]=s[i]&0x7f;
	}
if(debug>0)
	if(buf>2047) buffer[buf++]='#';
	else buffer[buf++]='_'; 

	*plen=buf;
	strncpy(s,buffer,buf);

	return (s);
}




/*
	Jis to EUC-Jis
*/
char *jis2ejis (s,plen,inst)
     char *s;
     int *plen;
     int inst;
{
  int i,buf,in_jis;
	
	in_jis=0; buf=0;
	for (i = 0; i < *plen; i++) {
	  if(!in_jis) {		/* head of JIS sequence */
		if(((i<*plen-3)&&(s[i]==0x1b) &&(s[i+1]=='$')&&(s[i+2]=='@')) 
		|| ((i<*plen-3)&&(s[i]==0x1b) &&(s[i+1]=='$')&&(s[i+2]=='B'))){
			i += 3;
			in_jis=1;
if(debug>1)
	buffer[buf++]='<'; 
		}
	  } else {		/* end of JIS sequence */
		if(((i<*plen-3)&&(s[i]==0x1b) &&(s[i+1]=='(')&&(s[i+2]=='J')) 
		|| ((i<*plen-3)&&(s[i]==0x1b) &&(s[i+1]=='(')&&(s[i+2]=='B'))){
			i += 3;
			in_jis=0;
if(debug>1)
	buffer[buf++]='>'; 
		}
	  }
	  if(in_jis) buffer[buf++]=s[i]|0x80;
	  else buffer[buf++]=s[i];
	}
if(debug>0)
	if(buf>2047) buffer[buf++]='#';
	else buffer[buf++]='_'; 
	if(buf>2047) buf=2047;

	*plen = buf;
	strncpy(s,buffer,buf);

	return (s);
}

/*
	EUC-Jis to Jis
*/
char *ejis2jis (s,plen,inst)
     char *s;
     int *plen;
     int inst;
{
  int i,buf,in_ejis;
	static unsigned char	c;
	
	in_ejis=0; buf=0;
	for (i = 0; i < *plen; i++) {
		c=s[i];
		if(!in_ejis) {
			if(ejis(c)) { /* head of EJIS sequence */
if(debug>1)
	buffer[buf++]='<'; 
				buffer[buf++]=0x1b;
				buffer[buf++]='$';
				buffer[buf++]='@';
				buffer[buf++]=c&0x7f;
				in_ejis=1;
			} else buffer[buf++]=c;
		} else {
			if(!ejis(c)) { /* end of EJIS sequence */
				buffer[buf++]=0x1b;
				buffer[buf++]='(';
				buffer[buf++]='J';
if(debug>1)
	buffer[buf++]='>'; 
				buffer[buf++]=c;
				in_ejis=0;
			} else buffer[buf++]=c&0x7f;
		}
	}
	if(in_ejis) { /* enforce end of EJIS sequence */
		buffer[buf++]=0x1b;
		buffer[buf++]='(';
		buffer[buf++]='J';
	}
if(debug>0)
	if(buf>2047) buffer[buf++]='#';
	else buffer[buf++]='_'; 
	if(buf>2047) buf=2047;

	*plen = buf;
	strncpy(s,buffer,buf);

	return (s);
}






/*
	Shift-Jis to EUC-Jis
*/
char *sjis2ejis (s,plen,inst)
     char *s;
     int *plen;
     int inst;
{
	int i,buf;
	static unsigned char	c1,c2,e1,e2;
	
	buf=0;
	for (i = 0; i < *plen; i++) {

		c1=s[i]; c2=s[i+1];

		if(c1 & 0x80) { /* head of SJIS sequence */

			if((c1>=0xa1) && (c1<=0xdf)) {
if(debug>1)
	buffer[buf++]='<'; 

                        	c1 &= 0x7f; 

                                if(c1=='$') c1 = ','; 
                                else if(c1=='!') c1= '.'; 
 
                                buffer[buf++] = c1&0x7f; 

				continue;
			}

                        c1 &= 0x0ff; 
                        c2 &= 0x0ff; 
 
                        e1 = c1 + c1 - ((c1 <= 0x9f) ? 0xe1 : 0x161); 
                        if (c2 < 0x9f) 
                            e2 = c2 - ((c2 > 0x7f) ? 0x20 : 0x1f); 
                        else { 
                            e2 = c2 - 0x7e; 
                            e1++; 
                        } 
 
                        e1 |= 0x80; 
                        e2 |= 0x80; 

			buffer[buf++]=e1;
			buffer[buf++]=e2;

			i++;

		} else {

if(debug>1)
	buffer[buf++]='>'; 
			buffer[buf++]=c1;

		}
	}
	
if(debug>0)
	if(buf>2047) buffer[buf++]='#';
	else buffer[buf++]='_'; 

	if(buf>2047) buf=2047;

	*plen = buf;
	strncpy(s,buffer,buf);

	return (s);
}

/*
	EUC-Jis to Shift-Jis
*/
char *ejis2sjis (s,plen,inst)
     char *s;
     int *plen;
     int inst;
{
	int i,buf;
	static unsigned char	c1,c2,e1,e2;
	
	buf=0;
	for (i = 0; i < *plen; i++) {

		c1=s[i]; c2=s[i+1];

		if(ejis(c1) && ejis(c2)) { /* head of EJIS sequence */
if(debug>1)
	buffer[buf++]='<'; 

                        c1 &= 0x7f; 
                        c2 &= 0x7f; 
 
                e1=((c1 - 1) >> 1) + ((c1 <= 0x5e) ? 0x71 : 0xb1); 
                e2=((c2 + ((c1 & 1) ? ((c2 < 0x60) ? 0x1f : 0x20) : 0x7e))); 

			buffer[buf++]=e1;
			buffer[buf++]=e2;

			i++;

		} else {

if(debug>1)
	buffer[buf++]='>'; 
			buffer[buf++]=c1;

		}
	}
if(debug>0)
	if(buf>2047) buffer[buf++]='#';
	else buffer[buf++]='_'; 

	if(buf>2047) buf=2047;

	*plen = buf;
	strncpy(s,buffer,buf);

	return (s);
}


/*
int ejis2big_init (arg)
     char *arg;
{
  static hz2gb_inst = 0;
	extern struct code_table j2b_tbl;

	memcpy(&table, &j2b_tbl, sizeof(struct code_table));
	table.loaded = 1;


if(debug>1) {
puts("ejis2big_init...");


	printf("\ntable.tbl_name = %s", table.tbl_name);
	printf("\ntable.row = %d", table.row);
	printf("\ntable.char_per_row = %d", table.char_per_row);
	printf("\ntable.length3_tbl_size = %d", table.length3_tbl_size);
}

}
*/

unsigned short nulltbl[]={
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

