#ifndef _VSOCKET_H
#define _VSOCKET_H

#ifdef _MSC_VER
#include <winsock.h>
#include "ysocket.h"
#define SELF_AF_UNIX
#define SELF_RESOLV_H

#else

#include <sys/types.h>
#include <netdb.h>

#ifdef __EMX__
#include "ysocket.h"
#define TCPIPV4
#ifndef MAXSOCKETS
#define MAXSOCKETS 2048
#endif
#endif


#ifdef __CYGWIN32__
#define SO_SNDBUF	0x1001
#define SO_RCVBUF	0x1002
#define SO_TYPE		0x1008
#define SELF_AF_UNIX
#define SELF_RESOLV_H
#else
#ifndef IPPROTO_TCP
#include <sys/param.h>
#endif
#endif

#include <sys/time.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#ifndef __CYGWIN32__
#include <netinet/tcp.h>
#include <sys/un.h>
#include <arpa/nameser.h>
#include <resolv.h>
#endif

extern char *inet_ntoa();
extern int getsockname(),getpeername();
#endif /* _MSC_VER */

#ifdef SELF_AF_UNIX
struct sockaddr_un {
	short	sun_family;	/* AF_UNIX */
	char	sun_path[108];	/* path name */
};
#endif

#ifdef SELF_RESOLV_H
#ifndef _RESOLV_H_
#define	_RESOLV_H_

#define MAXDNAME 		128
#define	MAXNS			3
#define	MAXDFLSRCH		3
#define	MAXDNSRCH		6
#define	LOCALDOMAINPARTS	2
#define	RES_TIMEOUT		5
#define	MAXRESOLVSORT		10
#define	RES_MAXNDOTS		15

typedef struct sockaddr_in _SIN;

struct state {
	long	options;
	int	nscount;
	_SIN	nsaddr_list[MAXNS];
	char   *dnsrch[MAXDNSRCH+1];
	char	defdname[MAXDNAME];
};

#define RES_INIT	0x00000001
#define RES_DEBUG	0x00000002
#define RES_RECURSE	0x00000040
#define RES_DEFNAMES	0x00000080
#define RES_DNSRCH	0x00000200

extern struct state _res;

#endif /* !_RESOLV_H */
#endif /* _SELF_RESOLV_H */
#endif /* _VSOCKET_H */


#define PS_IN     001
#define PS_PRI    002
#define PS_OUT    004
#define PS_ERR    010
#define PS_HUP    020
#define PS_NVAL   040
#define PS_ERRORS 070
