/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1997 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, modify, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:   program/C; charset=US-ASCII
Program:        hostaddr.c
Author:         Yutaka Sato <ysato@etl.go.jp>
Description:
History:
        970728	extracted from inets.c and windows.c
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>
#include "vsocket.h"

unsigned short ntohS(si) unsigned short si; {	return ntohs(si); }
unsigned short htonS(si) unsigned short si; {	return htons(si); }
unsigned long  ntohL(li) unsigned long  li; {	return ntohl(li); }
unsigned long  htonL(li) unsigned long  li; {	return htonl(li); }

char *inet_ntoaV4(in)
	struct in_addr in;
{
	return inet_ntoa(in);
}
char *inet_ntoaV4I(ia)
	unsigned long ia;
{	struct in_addr in;

	in.s_addr = ia;
	return inet_ntoaV4(in);
}
unsigned long inet_addrV4(cp)
	char *cp;
{
	return inet_addr(cp);
}


/*########################################
 *	INHERENT RESOLVER UTILIZATION
 */

#ifdef gethostbyname
#undef gethostbyname
#endif
struct hostent *RES_gethostbyname();
struct hostent *
_GETHOSTBYNAME(name)
	char *name;
{	struct hostent *ht;

	if( ht = RES_gethostbyname(name) )
		return ht;
	else	return gethostbyname(name);
}

#ifdef gethostbyaddr
#undef gethostbyaddr
#endif
struct hostent *RES_gethostbyaddr();
struct hostent *
_GETHOSTBYADDR(addr,len,type)
	char *addr;
{	struct hostent *ht;

	if( ht = RES_gethostbyaddr(addr,len,type) )
		return ht;
	else	return gethostbyaddr(addr,len,type);
}

