/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1997 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, modify, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	schedmain.c (scheduler)
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	970815	created
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>

extern int sched_DEBUG;
extern void *sched_create();

static do_action(_,action,ptime,pcode)
	void *_;
	char *action;
	long ptime;
{
 syslog_DEBUG("ACTION: %s\n",action);
	system(action);
	return 0;
}
main(ac,av)
	char *av[];
{	char line[1024];
	void *Cron;
	long next;
	int ai;
	char *arg;
	int wait;
	FILE *cfp;

	Cron = sched_create();
	if( ac < 2 ){
		fprintf(stderr,"Usage: %s cronspec | /path/of/cronfile\r\n",
			av[0]);
		exit(1);
	}

	for( ai = 1; ai < ac; ai++ ){
		arg = av[ai];
		if( arg[0] == '-' ){
			if( arg[1] == 'v' ){
				sched_DEBUG = atoi(&arg[2]);
				if( sched_DEBUG == 0 )
					sched_DEBUG = 2;
			}
		}else
		if( arg[0] == '/' ){
			cfp = fopen(arg,"r");
			if( cfp == NULL ){
				fprintf(stderr,"Cannot open: %s\r\n",arg);
				exit(1);
			}
			while( fgets(line,sizeof(line),cfp) != NULL )
				if( sched_append(Cron,line) != 0 )
					exit(1);
			fclose(cfp);
		}else{
			if( sched_append(Cron,arg) != 0 )
				exit(1);
		}
	}

	for(;;){
		next = sched_eval(Cron,time(0),do_action);
		wait = next - time(0);
		if( wait < 0 ){
			/* no more activation will occur */
			break;
		}
 if( 1 <= sched_DEBUG )
 syslog_DEBUG("SLEEP: %d seconds\n",wait);
		sleep(wait);
	}
}
static tprintf(){
	char ctime[64];
	StrftimeLocal(ctime,sizeof(ctime),"%H:%M:%S",time(0));
	printf("%s ",ctime);
}
syslog_DEBUG(fmt, a, b, c, d, e, f, g, h, i, j, k, l, m, n)
       char *fmt,*a,*b,*c,*d,*e,*f,*g,*h,*i,*j,*k,*l,*m,*n;
{
      if( sched_DEBUG < 2 )
	return;
      tprintf();
      printf(fmt, a, b, c, d, e, f, g, h, i, j, k, l, m, n);
}
syslog_ERROR(fmt, a, b, c, d, e, f, g, h, i, j, k, l, m, n)
       char *fmt,*a,*b,*c,*d,*e,*f,*g,*h,*i,*j,*k,*l,*m,*n;
{
      if( sched_DEBUG < 1 )
	return;
      tprintf();
      printf(fmt, a, b, c, d, e, f, g, h, i, j, k, l, m, n);
}
