/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1997 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, modify, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	editconf.c (DeleGate configuration editor)
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	970117	created
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>
#include <string.h>
extern char *strdup();
extern char *getADMIN();
#define LNSIZE	1024

static getparam(line,param)
	char *line,*param;
{	int len;
	char *dp;

	if( *param == '-' )
		strcpy(line,param);
	else	sprintf(line,"%s=",param);
	len = strlen(line);

	printf("%s",line);
	fflush(stdout);
	fgets(line+len,LNSIZE-len,stdin);
	if( dp = strpbrk(line,"\r\n") )
		*dp = 0;
	if( line[len] )
		return 1;
	else	return 0;
}

editconf(ac,avp)
	char ***avp;
{	char line[LNSIZE];
	static char *nav[128];
	char **av,arg1[128];
	int ac0,ai;

	ac0 = ac;
	av = *avp;
	for( ai = 0; ai < ac; ai++ )
		nav[ai] = av[ai];
	nav[ai] = NULL;

	printf("Administrator's E-mail ## ADMIN=user@domain [%s]\n",getADMIN());
	if( getparam(line,"ADMIN") ) nav[ac++] = strdup(line);

	printf("Port of the DeleGate ## -P[hostName:]portNumber\n");
	if( getparam(line,"-P") ) nav[ac++] = strdup(line);
	else{
#ifndef MAIN
		int sock,port;
		sock = server_open("-",NULL,0,1);
		if( sockHostport(sock,&port) != -1 ){
			printf("-P%d\n",port);
			sprintf(arg1,"-P%d/%d",port,sock);
			nav[ac++] = strdup(arg1);
		}
#endif
	}

	printf("Client's Protocol ## SERVER=protocol[://defaultServer/]\n");
	if( getparam(line,"SERVER") ) nav[ac++] = strdup(line);

/*
	printf("Upper DeleGate's port ## MASTER=hostName:portNumber\n");
	if( getparam(line,"MASTER") ) nav[ac++] = strdup(line);
*/

	nav[ac++] = "-v";
	nav[ac] = NULL;

	printf("--\n");
	for( ai = ac0; ai < ac; ai++ )
		printf("%s\n",nav[ai]);

	*avp = nav;
	return ac;
}

#ifdef MAIN
main(ac,av)
	char *av[];
{
	editconf(ac,&av);
}
#endif
