#include <stdio.h>
#include <string.h>
extern char *strstr();
extern char *getenv();

#define DGU_MARK	"=@="
char *getv();

static char *help = "\
Usage: undelegate { -mosaic | - | filename } \n\
   Change URLs in specified file from the DeleGate format to the standard one.\n\
      -mosaic  Mosaic's global-history and hotlist-default \n\
      -        standard input to standard output \n\
";

main(ac,av)
	char *av[];
{	FILE *sfp,*ofp;
	char path[1024];
	char *home;

	if( ac < 2 ){
		fprintf(stderr,"%s",help);
	}else
	if( strcmp("-mosaic",av[1]) == 0 ){
		home = getenv("HOME");
		sprintf(path,"%s/.mosaic-hotlist-default",home);
		undelegate_file(path);
		sprintf(path,"%s/.mosaic-global-history",home);
		undelegate_file(path);
		return;
	}else
	if( strcmp("-",av[1]) == 0 )
		urls_undelegate(stdin,stdout);
	else	undelegate_file(av[1]);
}

undelegate_file(path)
	char *path;
{	FILE *sfp,*ofp;
	char npath[1024],opath[1024];
	int nud;

	fprintf(stderr,"-- UnDeleGate --: %s\n",path);
	if( sfp = fopen(path,"r") ){
		sprintf(npath,"%s#",path);
		if( ofp = fopen(npath,"w") ){
			if( nud = urls_undelegate(sfp,ofp) ){
				sprintf(opath,"%s~",path);
				rename(path,opath);
				rename(npath,path);
				fprintf(stderr,"%d undelegated, ",nud);
				fprintf(stderr,"old file has left as %s\n",
					opath);
			}else{
				fprintf(stderr,"Nothing undelegated.\n");
				unlink(npath);
			}
		}else	fprintf(stderr,"Cannot write: %s\n",npath);
	}else	fprintf(stderr,"Cannot open: %s\n",path);
}

urls_undelegate(sfp,ofp)
	FILE *sfp,*ofp;
{	char line[2046];
	int changed;

	changed = 0;
	while( fgets(line,sizeof(line),sfp) ){
		changed += url_undelegate_old(line);
		fputs(line,ofp);
	}
	return changed;
}

url_undelegate_old(urlxa)
	char *urlxa;
{	char *tp,*up;
	int len;
	char xvalues[4096];
	char *xav[64];
	int xac;
	char *xflags,*xproto,*xhostport,*xgtype,*xpath,*xsearch;
	char *sp;
	char path[2048];
	char urlx[4096];

	nonxalpha_unescape(urlxa,urlx,0);
	if( (tp = strstr(urlx,DGU_MARK)) == 0 )
		return 0;

	up = tp + strlen(DGU_MARK);
	len = scan_urlx(up,xvalues);
	if( len <= 0 )
		return 0;

	xac = stoV(xvalues,64,xav,'\n');
	xflags    = getv(xav,"xflags");
	xproto    = getv(xav,"xproto");
	xhostport = getv(xav,"xhostport");
	xgtype    = getv(xav,"xtype");

	if( xhostport == 0 )
		return 0;

	strcpy(tp,up+len);

	if( xproto == 0 )
		xproto = "http";

	sp = strstr(urlx,"://");
	if( sp == 0 )
		return 0;

	sp += 3;
	while( *sp && !strchr("/ \t\r\n\"",*sp) )
		sp++;

	if( sp[0] == '/' && sp[1] == '/' )
		sp += 1;

	sprintf(urlxa,"%s://%s",xproto,xhostport);
/* nonxalpha_escape(sp,urlxa+strlen()); */
	strcat(urlxa,sp);
	return 1;
}

fputLog(){ return 0; }
CallShio(){}
expclock(){}
CallSrelay(){}
keepPublic(){}
ProcTitle(){}
callDelegate1(){}
makeXproxy(){}
HostId(){ return 0; }
shiobar(){}
